<?php
/* This file has been auto-generated. Do not edit this file directly. */

abstract class Sabai_Addon_Content_Model_Base_Post extends SabaiFramework_Model_Entity
{
    public function __construct(SabaiFramework_Model $model)
    {
        parent::__construct('Post', $model);
        $this->_vars = array('post_title' => null, 'post_slug' => null, 'post_published' => 0, 'post_status' => null, 'post_views' => 0, 'post_entity_bundle_name' => null, 'post_entity_bundle_type' => null, 'post_id' => 0, 'post_created' => 0, 'post_updated' => 0, 'post_user_id' => 0);
    }

    public function __clone()
    {
        $this->_vars = array('post_id' => 0, 'post_created' => 0, 'post_updated' => 0) + $this->_vars;
    }

    public function __toString()
    {
        return $this->__get('title');
    }

    protected function _assignUser($user, $markDirty = true)
    {
        $this->_setVar('post_user_id', $user->id, $markDirty);
    }

    protected function _fetchUser()
    {
        if (!isset($this->_objects['User'])) {
            $this->_objects['User'] = $this->_model->UserIdentity($this->_vars['post_user_id']);
        }

        return $this->_objects['User'];
    }

    public function isOwnedBy($user)
    {
        return $this->user_id && $this->user_id == $user->id;
    }

    public function __get($name)
    {
        if ($name === 'title')
            return $this->_vars['post_title'];
        elseif ($name === 'slug')
            return $this->_vars['post_slug'];
        elseif ($name === 'published')
            return $this->_vars['post_published'];
        elseif ($name === 'status')
            return $this->_vars['post_status'];
        elseif ($name === 'views')
            return $this->_vars['post_views'];
        elseif ($name === 'entity_bundle_name')
            return $this->_vars['post_entity_bundle_name'];
        elseif ($name === 'entity_bundle_type')
            return $this->_vars['post_entity_bundle_type'];
        elseif ($name === 'id')
            return $this->_vars['post_id'];
        elseif ($name === 'created')
            return $this->_vars['post_created'];
        elseif ($name === 'updated')
            return $this->_vars['post_updated'];
        elseif ($name === 'user_id')
            return $this->_vars['post_user_id'];
        elseif ($name === 'User')
            return $this->_fetchUser();
        else
            return $this->fetchObject($name);
    }

    public function __set($name, $value)
    {
        if ($name === 'title')
            $this->_setVar('post_title', $value);
        elseif ($name === 'slug')
            $this->_setVar('post_slug', $value);
        elseif ($name === 'published')
            $this->_setVar('post_published', $value);
        elseif ($name === 'status')
            $this->_setVar('post_status', $value);
        elseif ($name === 'views')
            $this->_setVar('post_views', $value);
        elseif ($name === 'entity_bundle_name')
            $this->_setVar('post_entity_bundle_name', $value);
        elseif ($name === 'entity_bundle_type')
            $this->_setVar('post_entity_bundle_type', $value);
        elseif ($name === 'id')
            $this->_setVar('post_id', $value);
        elseif ($name === 'user_id')
            $this->_setVar('post_user_id', $value);
        elseif ($name === 'User')
            $this->_assignUser($value);
        else
            $this->assignObject($name, $value);
    }

    protected function _initVar($name, $value)
    {
        if ($name === 'post_published')
            $this->_vars['post_published'] = (int)$value;
        elseif ($name === 'post_views')
            $this->_vars['post_views'] = (int)$value;
        elseif ($name === 'post_id')
            $this->_vars['post_id'] = (int)$value;
        elseif ($name === 'post_created')
            $this->_vars['post_created'] = (int)$value;
        elseif ($name === 'post_updated')
            $this->_vars['post_updated'] = (int)$value;
        elseif ($name === 'post_user_id')
            $this->_vars['post_user_id'] = (int)$value;
        else
            $this->_vars[$name] = $value;
    }
}

abstract class Sabai_Addon_Content_Model_Base_PostRepository extends SabaiFramework_Model_EntityRepository
{
    public function __construct(SabaiFramework_Model $model)
    {
        parent::__construct('Post', $model);
    }

    public function fetchByUser($id, $limit = 0, $offset = 0, $sort = null, $order = null)
    {
        return $this->_fetchByForeign('post_user_id', $id, $limit, $offset, $sort, $order);
    }

    public function paginateByUser($id, $perpage = 10, $sort = null, $order = null)
    {
        return $this->_paginateByEntity('User', $id, $perpage, $sort, $order);
    }

    public function countByUser($id)
    {
        return $this->_countByForeign('post_user_id', $id);
    }

    public function fetchByUserAndCriteria($id, SabaiFramework_Criteria $criteria, $limit = 0, $offset = 0, $sort = null, $order = null)
    {
        return $this->_fetchByForeignAndCriteria('post_user_id', $id, $criteria, $limit, $offset, $sort, $order);
    }

    public function paginateByUserAndCriteria($id, SabaiFramework_Criteria $criteria, $perpage = 10, $sort = null, $order = null)
    {
        return $this->_paginateByEntityAndCriteria('User', $id, $criteria, $perpage, $sort, $order);
    }

    public function countByUserAndCriteria($id, SabaiFramework_Criteria $criteria)
    {
        return $this->_countByForeignAndCriteria('post_user_id', $id, $criteria);
    }

    protected function _getCollectionByRowset(SabaiFramework_DB_Rowset $rs)
    {
        return new Sabai_Addon_Content_Model_Base_PostsByRowset($rs, $this->_model->create('Post'), $this->_model);
    }

    public function createCollection(array $entities = array())
    {
        return new Sabai_Addon_Content_Model_Base_Posts($this->_model, $entities);
    }
}

class Sabai_Addon_Content_Model_Base_PostsByRowset extends SabaiFramework_Model_EntityCollection_Rowset
{
    public function __construct(SabaiFramework_DB_Rowset $rs, Sabai_Addon_Content_Model_Post $emptyEntity, SabaiFramework_Model $model)
    {
        parent::__construct('Posts', $rs, $emptyEntity, $model);
    }

    protected function _loadRow(SabaiFramework_Model_Entity $entity, array $row)
    {
        $entity->initVars($row);
    }
}

class Sabai_Addon_Content_Model_Base_Posts extends SabaiFramework_Model_EntityCollection_Array
{
    public function __construct(SabaiFramework_Model $model, array $entities = array())
    {
        parent::__construct($model, 'Posts', $entities);
    }
}